MAGICFILE=`file -v |sed -e '{s/magic file from \(.*\)/\1/p;s/^.*//p;}'`
if test ! -f $MAGICFILE
then
	echo Cant find $MAGICFILE
	echo append bedmagic yourself to the magic file used by the file command
	exit
fi
NEWMAGIC=/tmp/newbedmagic.$$
OLDMAGIC=/tmp/oldbedmagic.$$
file -m bedmagic testmarks.bedm >$NEWMAGIC
file  testmarks.bedm >$OLDMAGIC
if cmp -s $NEWMAGIC $OLDMAGIC
then
	echo Bed magic already added
else
	echo bedmagic appended to $MAGICFILE   
	echo old magic saved in $MAGICFILE.beforebed
	mv $MAGICFILE $MAGICFILE.beforebed
	cat $MAGICFILE.beforebed bedmagic >	 $MAGICFILE
fi
rm $NEWMAGIC $OLDMAGIC
