#ifndef __SHELL_H__
#define __SHELL_H__
#include <unistd.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/signal.h>
#include "varmacro.h"
static int statusdieprocessreturns;
#if 0
#if defined(USETHREADS) && defined(__linux__)
#define commonexec pthread_kill_other_threads_np(),
#else
#define commonexec 
#endif
#else
#define commonexec 
#endif

#ifndef OLDGCCVARMACRO
#define executor(...) ( commonexec execlp(__VA_ARGS__))
#else
#define executor(x...) ( commonexec execlp(x))
#endif

#ifndef OLDGCCVARMACRO
#define process(commando,...)   (!fork())?  executor(commando,commando,__VA_ARGS__,NULL):(wait(&statusdieprocessreturns),statusdieprocessreturns)
#else
#define process(commando,args...)   (!fork())?  executor(commando,commando,args,NULL):(wait(&statusdieprocessreturns),statusdieprocessreturns)
#endif
#endif

